import { InitializedRecord, RecordIdentity, RecordKeyMap, RecordKeyValue, RecordNormalizer, RecordSchema, StandardRecordNormalizer, StandardRecordNormalizerSettings, UninitializedRecord } from '@orbit/records';
import { Model } from 'ember-orbit';
import { RecordFieldsOrModel, RecordIdentityOrModel } from './model-aware-types';
import { ModelFields } from './model-fields';
export declare type ModelRecordNormalizerSettings = StandardRecordNormalizerSettings;
export declare function isStandardRecord(data: UninitializedRecord | ModelFields): data is UninitializedRecord;
export declare class ModelAwareNormalizer implements RecordNormalizer<string, RecordIdentityOrModel, RecordFieldsOrModel> {
    protected _normalizer: StandardRecordNormalizer;
    constructor(settings: ModelRecordNormalizerSettings);
    get keyMap(): RecordKeyMap | undefined;
    get schema(): RecordSchema;
    normalizeRecordType(type: string): string;
    normalizeRecordIdentity(identity: RecordIdentity | RecordKeyValue | Model): RecordIdentity;
    normalizeRecord(record: RecordFieldsOrModel): InitializedRecord;
}
